<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>18.1.5: Storage Classes</title>
<link href="sx4da.html" rev=precedes>
<link href="sx4fa.html" rel=precedes>
<link href="sx4a.html" rev=subdocument>
</head>
<body>
<H3>18.1.5: Storage Classes</H3>

<p>A full-blown declaration in C consists of several parts:
the <dfn>storage class</dfn>,
the <dfn>base type</dfn>,
any <dfn>type qualifiers</dfn>,
and a list of <dfn>declarators</dfn>,
where each declarator consists of:
an <dfn>identifier</dfn>,
additional characters
possibly indicating that it is a pointer, array, or function,
and finally an optional <dfn>initializer</dfn>.
We've met each of these parts at various points along the way,
although we have never explicitly mentioned or defined the
<dfn>storage class</dfn>.
The storage class is optional;
it generally appears at the beginning of the declaration
(before the base type)
if it appears at all.
At most one storage class may appear in any one declaration.
</p><p>We've seen two storage classes so far, <TT>extern</TT> and
<TT>static</TT>.
<TT>extern</TT> marks a declaration as an
<dfn>external declaration</dfn>,
indicating that the identifier declared has its
<dfn>defining instance</dfn> somewhere else
(where ``somewhere else'' might be somewhere else in
the same source file,
or in a different source file).
<TT>static</TT> is used in two different ways,
(1) to indicate that a global (``file scope'')
variable is private to one source file, and cannot be accessed
(even with external declarations) from other source files,
or
(2) to indicate that a local variable should have static duration,
such that it does not come and go as the function is called and
returns,
and so that its value persists between invocations of the
function.
</p><p>Besides these two,
there are three other storage classes.
<TT>register</TT> indicates that the programmer believes that the
variable will be heavily used,
and that it should be assigned to a high-speed CPU register
(rather than an ordinary memory location) if possible.
Explicit <TT>register</TT> declarations are rare these days,
because modern compilers generally do an excellent job,
all by themselves and without any hints,
of deciding which variables belong in machine registers.
A limitation of <TT>register</TT> variables is that you cannot
generate pointers to them using the <TT>&amp;</TT> operator.
(This is because, on most machines,
pointers are implemented as memory addresses,
and CPU registers usually do not have memory addresses.)
</p><p>The fourth storage class is <TT>auto</TT>,
which indicates that a local variable should have automatic duration.
(Automatic duration, remember,
means that variables are automatically allocated when a function
is called and automatically deallocated when it returns.)
Since automatic duration is the default for local variables anyway,
<TT>auto</TT> is virtually never used;
it's a relic from C's past.
</p><p>The fifth storage class,
<TT>typedef</TT>, is described in the next section.
</p><hr>
<p>
Read sequentially:
<a href="sx4da.html" rev=precedes>prev</a>
<a href="sx4fa.html" rel=precedes>next</a>
<a href="sx4a.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
